<template>
  <div id="modalWindow" class="modal-mask">
    <div class="modal-wrapper">
      <div class="modal-container">

        <div class="card-body">
          <div class="button-container">
          <button id="notifClose" @click="$emit('close')">
            <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="currentColor" class="bi bi-x-circle" viewBox="0 0 16 16">
              <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
              <path d="M4.646 4.646a.5.5 0 0 1 .708 0L8 7.293l2.646-2.647a.5.5 0 0 1 .708.708L8.707 8l2.647 2.646a.5.5 0 0 1-.708.708L8 8.707l-2.646 2.647a.5.5 0 0 1-.708-.708L7.293 8 4.646 5.354a.5.5 0 0 1 0-.708z"/>
            </svg>
          </button>
          </div>

          <h3 id="notifTitle" class="card-title">{{ title }}</h3>
          <div id="notifMessage" class="card-text pre-formatted">{{ body }}</div>
          <p><slot></slot></p>
        </div>

      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "ModalWindow",
  props: {
    title: {
      type: String
    },
    body: {
      type: String
    }
  }
}
</script>

<style scoped>
.pre-formatted {
  white-space: pre;
}

.button-container {
  display: flex;
  justify-content: right;
}

.bi-x-circle {
  color: #886565;
}

.modal-mask {
  position: fixed;
  z-index: 9998;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  display: table;
  transition: opacity 0.3s ease;
}

.modal-wrapper {
  display: table-cell;
  vertical-align: middle;
}

.modal-container {
  max-width: 43rem;
  padding: 1rem;
  height: max-content;
  margin: auto;
  background-color: #decebd;
  box-shadow: 0 0 0 100vmax rgba(0,0,0,.7);
  transition: all 0.3s ease;
}

.modal-header h3 {
  margin-top: 0;
}

.modal-enter .modal-container,
.modal-leave-active .modal-container {
  -webkit-transform: scale(1.1);
  transform: scale(1.1);
}

#notifClose, #notifClose:hover {
  background-color: transparent;
  border-color: transparent;
}

#notifTitle {
  color: #9b7272;
  margin-bottom: 2rem;
}

#notifMessage {
  margin: 1rem 0;
  color: #6d6d6d;
}
</style>